package ca.uwaterloo.crysp.trainertouchalytics;

import ca.uwaterloo.crysp.trainertouchalytics.R;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.Color;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.widget.TextView;

public class TracingActivity extends Activity {
	public static DrawingView drawingView;
	//public static boolean test = false;
	//public static boolean draw = false;
	public static Activity tracingActivity;
	static String [] featureLabels = {"1st X", "1st Y",
			"1st width", "1st dir.", "Distance", "Duration",
			"Avg. dir.", "Avg. curv.", "Avg. area",
			"Max area"};
	
	//Classifier classifier;
	KNNClassifier kc;
	SVMClassifier svm;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		this.requestWindowFeature(Window.FEATURE_NO_TITLE);
		setContentView(R.layout.activity_tracing);
		tracingActivity = this;
		//classifier = new Classifier(ConfigureActivity.user);
		kc = MainActivity.knn;
		svm = MainActivity.svm;
		drawingView = (DrawingView) findViewById(R.id.drawing);
		/*TextView textView = (TextView) findViewById(R.id.test);
		textView.setOnClickListener(linkHandler);
		textView = (TextView) findViewById(R.id.draw);
		textView.setOnClickListener(linkHandler);*/
		View v = findViewById(R.id.options);
		v.setOnClickListener(linkHandler);
		v.setVisibility(View.VISIBLE);
	}
	View.OnClickListener linkHandler = new View.OnClickListener() {
		@Override
		public void onClick(View v) {
			int id = v.getId();
			if (id == R.id.options);
				showFinishDialog();
			}
	};
	public static void setFinishLinkState(boolean state) {
		View v = tracingActivity.findViewById(R.id.options);
		if (state)
			v.setVisibility(View.VISIBLE);
		else
			v.setVisibility(View.VISIBLE);
	}
	@Override
    public boolean dispatchTouchEvent(MotionEvent ev) {
    	//Log.e("Tracing", "TouchDispatcher");
		if (TouchFeatures.procEvent(ev)) {
			double [] fv = TouchFeatures.getFV();
			double [] fvVals = MainActivity.positive.get(MainActivity.targetIndex);
			int score = svm.classify(fv);
			double [] diff = new double[fv.length];
			for (int i = 1; i < fv.length; i++) {
				diff[i] = fvVals[i]/svm.scalingFactor[i] - fv[i]/svm.scalingFactor[i];
				//diff[i] = fvVals[i] - fv[i];
			}
			DebugActivity.postProcessSwipe(score, diff, fvVals, fv);
			//toast_(score, fv, fvVals);
		}
    	DebugActivity.activity.dispatchTouchEvent(ev);
    	super.dispatchTouchEvent(ev);
    	return false;
    }
	
	public static void showPhaseDialog(String title, String message) {
		new AlertDialog.Builder(tracingActivity)
	    .setTitle(title)
	    .setMessage(message)
	    .setCancelable(false)
	    .setPositiveButton(android.R.string.yes, new DialogInterface.OnClickListener() {
	        public void onClick(DialogInterface dialog, int which) {
	            dialog.cancel();
	        }
	     })
	    .setIcon(android.R.drawable.ic_dialog_alert)
	     .show();
	}
	public static void showFinishDialog() {
		 AlertDialog.Builder builder = new AlertDialog.Builder(tracingActivity);
		    builder.setTitle("Training phase completed!!!");
		    builder.setItems(new CharSequence[]
		            {"Resume","Retry tracing", "Retry test", "Next"},
		            new DialogInterface.OnClickListener() {
		                public void onClick(DialogInterface dialog, int which) {
		                    // The 'which' argument contains the index position
		                    // of the selected item
		                    switch (which) {
		                    case 0:
		                    	dialog.dismiss();
	                            break;
		                    case 1:
		                        	DebugActivity.wrapperUpdateState(DebugActivity.TRACE_STATE);
		                            break;
		                    case 2:
		                        	DebugActivity.wrapperUpdateState(DebugActivity.TEST_STATE);
		                            break;
		                    case 3:
		                        	DebugActivity.activity.finish();
		                            break;
		                    }
		                }
		            });
		    builder.create().show();
	}
	
	/*
	<LinearLayout 
	android:layout_width="match_parent"
	android:layout_height="wrap_content"
		android:orientation="horizontal">
    <TextView
	        android:id="@+id/draw"
	        android:layout_width="wrap_content"
	        android:layout_height="wrap_content"
	        android:layout_marginLeft="5dp"
	        android:text="Draw"
	        android:onClick="onClick"                
	        android:clickable="true"
	        android:textColor="#0066cc" />

    <TextView
        android:id="@+id/test"
        android:layout_width="wrap_content"
        android:layout_height="wrap_content"
        android:layout_marginLeft="225dp"
        android:clickable="true"
        android:onClick="onClick"
        android:text="Test"
        android:textColor="#0066cc" />

</LinearLayout>*/
}
